"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function AllMethods(decorator) {
    return (target) => {
        Object.getOwnPropertyNames(target.prototype).forEach((key) => {
            const descriptor = Object.getOwnPropertyDescriptor(target.prototype, key);
            if (typeof descriptor.get !== 'undefined'
                || typeof descriptor.set !== 'undefined'
                || key === 'constructor'
                || key[0] === '_') {
                return;
            }
            const decoratorResult = decorator.call(target, target.prototype[key], key, descriptor);
            if (decoratorResult) {
                target.prototype[key] = decoratorResult;
            }
        });
        return target;
    };
}
exports.AllMethods = AllMethods;
