"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ts_graphite_decorator_1 = require("ts-graphite-decorator");
const helpers_1 = require("./helpers");
function Graphite(graphiteDefaultKey, graphiteUrl) {
    return function (target, propertyKey, descriptor) {
        const timingsKey = graphiteDefaultKey + 'timings.$method.';
        const rpmKey = graphiteDefaultKey + 'rpm.$method.';
        const classAndMethodName = helpers_1.getClassAndMethodName(this, propertyKey);
        ts_graphite_decorator_1.RPM(rpmKey + classAndMethodName, graphiteUrl)(target, classAndMethodName, descriptor);
        ts_graphite_decorator_1.Metered(timingsKey + classAndMethodName, graphiteUrl)(target, classAndMethodName, descriptor);
        return descriptor.value;
    };
}
exports.Graphite = Graphite;
