"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class DbError extends Error {
    constructor(data) {
        super(data.publicMessage || DbError.MESSAGE_DEFAULT);
        this.code = data.code || DbError.CODE_DEFAULT;
        this.status = data.status || DbError.STATUS_DEFAULT;
        this.innerDetails = data.innerDetails;
    }
}
DbError.CODE_DEFAULT = 'DB_ERROR';
DbError.STATUS_DEFAULT = 500;
DbError.MESSAGE_DEFAULT = 'Db query failed';
exports.DbError = DbError;
