"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function clock(start) {
    if (!start) {
        return process.hrtime();
    }
    const end = process.hrtime(start);
    return (end[0] * 1000) + (end[1] / 1000000);
}
function logMiddleware(ctx, next) {
    return __awaiter(this, void 0, void 0, function* () {
        const startTime = clock();
        const startTimeString = startTime.join('');
        console.debug(`request ${startTimeString}`);
        console.debug('url href is', ctx.request.href);
        console.debug('ctx request is', ctx.request);
        console.debug('ctx request method is', ctx.request.method);
        console.debug('ctx request query is', ctx.request.query);
        console.debug('ctx request body is', ctx.request.body);
        const result = yield next();
        console.debug(`Request ${startTimeString} finished in ${clock(startTime)} ms`);
        return result;
    });
}
exports.logMiddleware = logMiddleware;
