"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const cls_service_1 = require("../../services/cls_service");
const trace_1 = require("../../trace");
const X_B3_TRACE_ID_HEADER = 'X-B3-TraceId';
const X_B3_SPAN_ID_HEADER = 'X-B3-SpanId';
const X_B3_PARENT_SPAN_ID_HEADER = 'X-B3-ParentSpanId';
function traceMiddleware(ctx, next) {
    return __awaiter(this, void 0, void 0, function* () {
        const startTrace = new trace_1.Trace(ctx.req.headers[X_B3_TRACE_ID_HEADER], ctx.req.headers[X_B3_SPAN_ID_HEADER], ctx.req.headers[X_B3_PARENT_SPAN_ID_HEADER]);
        return yield cls_service_1.ClsService.createCls(() => __awaiter(this, void 0, void 0, function* () {
            cls_service_1.ClsService.setTrace(startTrace);
            const result = yield next();
            const endTrace = cls_service_1.ClsService.getTrace();
            ctx.set({
                [X_B3_TRACE_ID_HEADER]: endTrace.traceId,
                [X_B3_SPAN_ID_HEADER]: endTrace.spanId,
                [X_B3_PARENT_SPAN_ID_HEADER]: endTrace.parentSpanId
            });
            return result;
        }));
    });
}
exports.traceMiddleware = traceMiddleware;
