"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Trace {
    constructor(traceId = Trace._generateId(), spanId = traceId, parentSpanId = traceId) {
        this.traceId = traceId;
        this.spanId = spanId;
        this.parentSpanId = parentSpanId;
    }
    static _generateId() {
        return (Date.now() + (Math.floor(Math.random() * 10))).toString(16);
    }
    span() {
        this.parentSpanId = this.spanId;
        this.spanId = Trace._generateId();
    }
    toJSON() {
        return {
            traceId: this.traceId,
            spanId: this.spanId,
            parentSpanId: this.parentSpanId
        };
    }
}
exports.Trace = Trace;
